from django.contrib.syndication.feeds import Feed
from google.appengine.api import users
from models import Message
from gae import monkeypatch
from templatefilters import safe_google_nickname, unsafe_google_nickname

class MessageFeed(Feed):
    def get_object(self, bits):
        if len(bits) != 1:
            return None
        else:
            email = unsafe_google_nickname(bits[0])            
            return users.User(email=email)

    def title(self, obj):
        if obj:
            return "Meows for %s" % (safe_google_nickname(obj.nickname()),)
        else:
            return "All Meows"
    
    def link(self, obj):
        if obj:
            return "/%s/" % (safe_google_nickname(obj.nickname()),)
        else:
            return "/"
    
    def description(self, obj):
        if obj:
            return "Most recent meows for %s" % (safe_google_nickname(obj.nickname()),)
        else:
            return "Most recent meows."

    def items(self, obj):
        if obj:
            query = Message.all()
            query.filter("author =", obj).order("-date")
            return query.fetch(10)
        else:
            query = Message.all()
            query.order("-date")
            return query.fetch(10)
            
    def item_link(self, item):
        return "/message/%s" % item.key()
