from django.core.validators import email_re
from google.appengine.ext import webapp
from google.appengine.api import users
register = webapp.template.create_template_register()

@register.filter
def safe_google_nickname(value):
    """This turns a google apps for domains email into something safer

    Let's hope someone doesn't have an email address of 
    user_at_domain@gmail.com
    """
    if type(value) == users.User:
        value = value.nickname()

    if email_re.search(value):
        return value.replace("@","_at_")
    else:
        return value

def unsafe_google_nickname(value):
    """This returns the nickname to it's original unsafe self"""
    if "_at_" in value:
        return value.replace("_at_", "@")
    else:
        return value + "@gmail.com"
